unit Font_Dialog;

interface

uses
{$ifdef Linux}
  SysUtils, Classes, QGraphics, QControls, QForms, 
  QDialogs, QStdCtrls, QExtCtrls, QClipbrd, StdCtrls, Controls, ExtCtrls;
{$else}
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Clipbrd, IniFiles;
{$endif}

type
  TFontSelector = class(TForm)
    Label1: TLabel;
    cbA: TComboBox;
    Label2: TLabel;
    cbG: TComboBox;
    Label3: TLabel;
    cbM: TComboBox;
    Label4: TLabel;
    cbR: TComboBox;
    Label5: TLabel;
    cbS: TComboBox;
    cbV: TComboBox;
    Label6: TLabel;
    Panel1: TPanel;
    Cancel: TButton;
    procedure HelpButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure OKClick(Sender: TObject);
  private
    { Private  }
  public
    { Public  }
  end;

var
  FontSelector: TFontSelector;

implementation

uses Grapher_Main;

{$R *.xfm}

procedure TFontSelector.HelpButtonClick(Sender: TObject);
begin
  {$ifdef Linux}
  InvokeHelp;
  {$else}
  Keybd_Event(VK_F1, 0, 0, 0);
  {$endif}
end;

procedure TFontSelector.FormCreate(Sender: TObject);
begin
  cbA.Items.Assign(AvFonts);
  cbG.Items.Assign(AvFonts);
  cbM.Items.Assign(AvFonts);
  cbR.Items.Assign(AvFonts);
  cbS.Items.Assign(AvFonts);
  cbV.Items.Assign(AvFonts);
end;

procedure TFontSelector.FormShow(Sender: TObject);
  procedure SetCurFont(cb: TComboBox; FName: TFontName);
  var i: Integer;
  begin
    i := 0;
    repeat
      i := i + 1;
    until (FName= cb.Items[i]) or (i = cb.Items.Count - 1);
    cb.ItemIndex := i;
  end;
begin
  SetCurFont(cbA, Main.HyperText.FontNameA);
  SetCurFont(cbG, Main.HyperText.FontNameG);
  SetCurFont(cbM, Main.HyperText.FontNameM);
  SetCurFont(cbR, Main.HyperText.FontNameR);
  SetCurFont(cbS, Main.HyperText.FontNameS);
  SetCurFont(cbV, Main.HyperText.FontNameV);
end;

procedure TFontSelector.OKClick(Sender: TObject);
begin
  Main.HyperText.FontNameA := cbA.Text;
  Main.HyperText.FontNameG := cbG.Text;
  Main.HyperText.FontNameM := cbM.Text;
  Main.HyperText.FontNameR := cbR.Text;
  Main.HyperText.FontNameS := cbS.Text;
  Main.HyperText.FontNameV := cbV.Text;
end;

end.
