unit Frame_Dialog;

interface

uses
{$ifdef Linux}
  SysUtils, Classes, QGraphics, QControls, QForms, 
  QDialogs, QStdCtrls, QExtCtrls, QComCtrls, QMenus, Math, 
  Title_Editor, IniFiles, QButtons, Dialogs, Buttons, StdCtrls, Forms,
  ExtCtrls, Controls;
{$else}
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, ToolWin, Menus, Math, Title_Editor, IniFiles, Buttons;
{$endif}

type
  TFrameDialog = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Label5: TLabel;
    Edit5: TEdit;
    Label7: TLabel;
    Edit6: TEdit;
    Label8: TLabel;
    Edit7: TEdit;
    Label9: TLabel;
    Edit8: TEdit;
    GroupBox1: TGroupBox;
    cbFont: TComboBox;
    cbFontSize: TComboBox;
    Panel2: TPanel;
    OK: TButton;
    CancelButton: TButton;
    Panel1: TPanel;
    Label6: TLabel;
    Label10: TLabel;
    Edit9: TEdit;
    cbBorderStyle: TComboBox;
    Label11: TLabel;
    TitleEditor: TTitleEditor;
    HelpButton: TButton;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    Edit10: TEdit;
    bbPicOpen: TBitBtn;
    Edit11: TEdit;
    Label12: TLabel;
    GroupBox2: TGroupBox;
    Edit12: TEdit;
    Label13: TLabel;
    procedure ExecuteClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure OKClick(Sender: TObject);
    procedure cbBorderStyleChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TitleEditorEnter(Sender: TObject);
    procedure HelpButtonClick(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure TitleEditorMemoExit(Sender: TObject);
    procedure cbFontSizeChange(Sender: TObject);
    procedure bbPicOpenClick(Sender: TObject);
  private
  public
  end;

var
  FrameDialog: TFrameDialog;
  Msg : array[1..6] of String;

implementation

uses Grapher_Main, Legend_Dialog;

{$R *.xfm}

procedure TFrameDialog.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
  S, ResourceFileName: String;
  i: Integer;
  procedure GetComboBoxItems(CB: TComboBox );
  begin
    i := CB.ItemIndex;
    CB.Items.Text := StringReplace(IniFile.ReadString(S, CB.Name +  '.Items.Text', ''), '<br>', #13#10, [rfReplaceAll, rfIgnoreCase]);
    CB.ItemIndex := i;
  end;
begin
  S := Self.Name;
  ResourceFileName := ChangeFileExt(Application.ExeName, '.lng');
  Font.Assign(Main.Font);
  if FileExists(ResourceFileName) then
  begin
    IniFile := TIniFile.Create(ResourceFileName);
    with IniFile do
      try
        Caption              := ReadString(S, 'FrameDialog.Caption', '');
        Label1.Caption       := ReadString(S, 'Label1.Caption', '');
        Label2.Caption       := ReadString(S, 'Label2.Caption', '');
        Label3.Caption       := ReadString(S, 'Label3.Caption', '');
        Label4.Caption       := ReadString(S, 'Label4.Caption', '');
        Label5.Caption       := ReadString(S, 'Label5.Caption', '');
        Label7.Caption       := ReadString(S, 'Label7.Caption', '');
        Label8.Caption       := ReadString(S, 'Label8.Caption', '');
        Label9.Caption       := ReadString(S, 'Label9.Caption', '');
        GroupBox1.Caption    := ReadString(S, 'GroupBox1.Caption', '');
        GroupBox2.Caption    := ReadString(S, 'GroupBox2.Caption', '');
        Label11.Caption      := ReadString(S, 'Label11.Caption', '');
        CancelButton.Caption := ReadString(S, 'CancelButton.Caption', '');
        HelpButton.Caption   := ReadString(S, 'HelpButton.Caption', '');
        Label6.Caption       := ReadString(S, 'Label6.Caption', '');
        Label10.Caption      := ReadString(S, 'Label10.Caption', '');
        CheckBox1.Caption    := ReadString(S, 'CheckBox1.Caption', '');
        CheckBox2.Caption    := ReadString(S, 'CheckBox2.Caption', '');
        Label12.Caption := Label8.Caption;
        Label13.Caption := Label9.Caption;
        GetComboBoxItems(cbBorderStyle);
        for i := 1 to 6 do
          Msg[i] := StringReplace(ReadString(S, 'Msg' + IntToStr(i), ''), '<br>', #13#10, [rfReplaceAll, rfIgnoreCase]);
      finally
        Free;
      end;
  end;
  if LANG = 128 then
  begin
    TitleEditor.FontComboBox.Items.Add(Msg[1]);
    TitleEditor.FontComboBox.Items.Add(Msg[2]);
    Label3.Left := Label3.Left + 12;
    Label4.Left := Label4.Left + 12;
    Label6.Left := Label6.Left - 5;
    Label7.Left := Label7.Left + 30;
    Label8.Left := Label8.Left + 30;
    Label9.Left := Label9.Left + 30;
  end;
end;

procedure TFrameDialog.FormShow(Sender: TObject);
var i : Integer;
begin
 // Screen.Cursor := crHourGlass;
  cbFontSize.ItemIndex := Main.ToolBar.Font.Size - 6;
  cbFont.Items := AvFonts;// Screen.Fonts;
  //Screen.Cursor := crDefault;
  Edit1.Text := IntToStr(Glmargin);
  Edit2.Text := IntToStr(Gtmargin);
  Edit3.Text := IntToStr(Gwidth);
  Edit4.Text := IntToStr(Gheight);
  Edit5.Text := FormatFloat('0.0', FLine_Width);
  i := 0;
  repeat
    i := i + 1;
  until (Main.ToolBar.Font.Name = cbFont.Items[i]) or (i = cbFont.Items.Count - 1);
  cbFont.ItemIndex := i;
 // i := 0;
 // repeat
 //   i := i + 1;
 // until IntToStr(ToolBar.Font.Size) = cbFont.Items[i];
  dumstr := Legend[1];
  TitleEditor.Memo.Lines.Clear;
  repeat
    TitleEditor.Memo.Lines.Add(Copy(dumstr, 1, Pos('\n', dumstr) - 1));
    dumstr := Copy(dumstr, Pos('\n', dumstr) + 2, 500);
  until dumstr = '';
  Edit6.Text := FormatFloat('#0.0', LegendLspacing[1]);
  Edit7.Text := FormatFloat('##0.0', LegendXshift[1]);
  Edit8.Text := FormatFloat('##0.0', LegendYshift[1]);
  cbBorderStyle.ItemIndex := lblBorderType[target];
  Edit9.Text := FloatToStr(lblMargin[target]);
  CheckBox1.Checked := For_Math;
  CheckBox2.Checked := AutoOxy;
  if FileExists(BackgroundImage) then
    Edit10.Text := Main.GetRelativeDirectory(FigDir, BackgroundImage);
  Edit11.Text := IntToStr(BIxshift);
  Edit12.Text := IntToStr(BIyshift);
  CheckBox1Click(Sender);
end;
//----------------------------------------------------------
procedure TFrameDialog.ExecuteClick(Sender: TObject);
begin
  Close;
end;
//----------------------------------------------------------
procedure TFrameDialog.OKClick(Sender: TObject);
var i : Integer;
begin
  {
  if Glmargin <> StrToInt(Edit1.Text) then ClearZone;
  if Gtmargin <> StrToInt(Edit2.Text) then ClearZone;
  if Gwidth   <> StrToInt(Edit3.Text) then ClearZone;
  if Gheight  <> StrToInt(Edit4.Text) then ClearZone;
  }
  Glmargin := StrToInt(Edit1.Text);
  Gtmargin := StrToInt(Edit2.Text);
  Gwidth   := StrToInt(Edit3.Text);
  Gheight  := StrToInt(Edit4.Text);
  FLine_Width :=  StrToFloat(Edit5.Text);
  Main.ToolBar.Font.Name := cbFont.Items[cbFont.ItemIndex];
  Main.ToolBar.Font.Size := cbFontSize.ItemIndex + 6;
  Legend[1] := '';
  i := 0;
  while TitleEditor.Memo.Lines[i] <> ''do
  begin
    Legend[1] := Legend[1] + TitleEditor.Memo.Lines[i] + '\n';
    i := i + 1;
  end;
  LegendLspacing[1]:= StrToFloat(Edit6.Text);
  LegendXshift[1] := StrToFloat(Edit7.Text);
  LegendYshift[1] := StrToFloat(Edit8.Text);
  lblBorderType[1]  := cbBorderStyle.ItemIndex;
  lblMargin[1] := StrToFloat(Edit9.Text);
  For_Math := CheckBox1.Checked;
  AutoOxy  := CheckBox2.Checked;
  if Edit10.Text <> '' then
    BackgroundImage := Main.GetAbsoluteDirectory(FigDir, Edit10.Text)
  else
    BackgroundImage := '';
  Main.LoadBackgroundImage;
  BIxshift := StrToInt(Edit11.Text);
  BIyshift  := StrToInt(Edit12.Text);
  Main.ActivateAxes;
 // Main.WriteLegend;
  Modified[NumFigure] := 1;
  Close;
end;

procedure TFrameDialog.cbBorderStyleChange(Sender: TObject);
begin
  if cbBorderStyle.ItemIndex = 0 then
    Edit9.Enabled := False
  else
    Edit9.Enabled := True;
end;

procedure TFrameDialog.TitleEditorEnter(Sender: TObject);
begin
  TitleEditor.DefaultFont := Main.ToolBar.Font;
  TitleEditor.DefaultFont.Color := clBlack;
  TitleEditor.HyperText.Shadow := False;
  PopupMenu := TitleEditor.PopupMenu;
  TitleEditor.FrameEnter(Sender);
end;

procedure TFrameDialog.HelpButtonClick(Sender: TObject);
begin
  {$ifdef Linux}
  //Main.IndexClick(Sender);
  InvokeHelp;
  {$else}
  Keybd_Event(VK_F1, 0, 0, 0);
  {$endif}
end;

procedure TFrameDialog.CheckBox1Click(Sender: TObject);
begin
  CheckBox2.Enabled := CheckBox1.Checked;
end;

procedure TFrameDialog.TitleEditorMemoExit(Sender: TObject);
begin
  PopupMenu := nil;
end;

procedure TFrameDialog.cbFontSizeChange(Sender: TObject);
begin
  Edit6.Text := IntToStr(4 + Trunc(0.4 * (StrToInt(cbFontSize.Text) - 7))) + '.0';
end;

procedure TFrameDialog.bbPicOpenClick(Sender: TObject);
begin
  Main.mmBGIClick(Sender);
  if FileExists(Main.OpenPictureDialog.FileName) then
    Edit10.Text := Main.GetRelativeDirectory(FigDir, Main.OpenPictureDialog.FileName);
end;

end.
